﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Tilde.MT.WebsiteTranslationService.Models.Database;

#nullable disable

namespace Tilde.MT.WebsiteTranslationService.Migrations
{
    [DbContext(typeof(ServiceDbContext))]
    [Migration("20240902085509_AddedTranslationImportStatusTable")]
    partial class AddedTranslationImportStatusTable
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "8.0.2")
                .HasAnnotation("Relational:MaxIdentifierLength", 64);

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Segment", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    MySqlPropertyBuilderExtensions.UseMySqlIdentityColumn(b.Property<long>("Id"));

                    b.Property<DateTime?>("DbCreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DbUpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<long>("SegmentMetadataId")
                        .HasColumnType("bigint");

                    b.Property<string>("TextNormalized")
                        .IsRequired()
                        .HasMaxLength(64)
                        .HasColumnType("varchar(64)");

                    b.Property<string>("TextRaw")
                        .IsRequired()
                        .HasMaxLength(5000)
                        .HasColumnType("varchar(5000)");

                    b.Property<string>("Uri")
                        .IsRequired()
                        .HasMaxLength(512)
                        .HasColumnType("varchar(512)");

                    b.Property<string>("UriId")
                        .IsRequired()
                        .HasMaxLength(64)
                        .HasColumnType("varchar(64)");

                    b.Property<Guid>("WebsiteId")
                        .HasColumnType("char(36)");

                    b.HasKey("Id");

                    b.HasIndex("SegmentMetadataId");

                    b.HasIndex("TextNormalized")
                        .HasAnnotation("MySql:IndexPrefixLength", new[] { 64 });

                    b.HasIndex("TextRaw")
                        .HasAnnotation("MySql:IndexPrefixLength", new[] { 768 });

                    b.HasIndex("TextNormalized", "WebsiteId", "UriId", "SegmentMetadataId")
                        .IsUnique();

                    b.ToTable("segments");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentMetadata", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    MySqlPropertyBuilderExtensions.UseMySqlIdentityColumn(b.Property<long>("Id"));

                    b.Property<string>("Attribute")
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<bool>("IsSEO")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("ReferencedAttribute")
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<string>("Tag")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.HasKey("Id");

                    b.HasIndex("Attribute", "ReferencedAttribute", "Tag", "IsSEO")
                        .IsUnique();

                    b.ToTable("segment-metadata");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslation", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    MySqlPropertyBuilderExtensions.UseMySqlIdentityColumn(b.Property<long>("Id"));

                    b.Property<long?>("AcceptedTranslationId")
                        .HasColumnType("bigint");

                    b.Property<DateTime?>("DbCreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DbUpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<long>("SegmentId")
                        .HasColumnType("bigint");

                    b.Property<int>("Status")
                        .HasColumnType("int");

                    b.Property<Guid>("WebsiteId")
                        .HasColumnType("char(36)");

                    b.Property<string>("WebsiteTargetLanguageName")
                        .IsRequired()
                        .HasColumnType("varchar(255)");

                    b.HasKey("Id");

                    b.HasAlternateKey("SegmentId", "WebsiteTargetLanguageName");

                    b.HasIndex("AcceptedTranslationId");

                    b.ToTable("segment-translations");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslationHistory", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    MySqlPropertyBuilderExtensions.UseMySqlIdentityColumn(b.Property<long>("Id"));

                    b.Property<long>("SegmentTranslationId")
                        .HasColumnType("bigint");

                    b.Property<long>("TranslationId")
                        .HasColumnType("bigint");

                    b.HasKey("Id");

                    b.HasIndex("SegmentTranslationId");

                    b.HasIndex("TranslationId", "SegmentTranslationId")
                        .IsUnique();

                    b.ToTable("SegmentTranslationHistories");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Translation", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    MySqlPropertyBuilderExtensions.UseMySqlIdentityColumn(b.Property<long>("Id"));

                    b.Property<DateTime?>("DbCreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DbUpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<int>("Origin")
                        .HasColumnType("int");

                    b.Property<string>("Text")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.ToTable("translations");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.TranslationImportStatus", b =>
                {
                    b.Property<Guid>("ConfigurationId")
                        .HasColumnType("char(36)");

                    b.Property<int>("ImportStatus")
                        .HasColumnType("tinyint");

                    b.HasKey("ConfigurationId");

                    b.ToTable("TranslationImportStatuses");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Segment", b =>
                {
                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentMetadata", "SegmentMetadata")
                        .WithMany("SegmentTranslations")
                        .HasForeignKey("SegmentMetadataId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("SegmentMetadata");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslation", b =>
                {
                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Translation", "AcceptedTranslation")
                        .WithMany()
                        .HasForeignKey("AcceptedTranslationId");

                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Segment", "Segment")
                        .WithMany("SegmentTranslations")
                        .HasForeignKey("SegmentId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("AcceptedTranslation");

                    b.Navigation("Segment");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslationHistory", b =>
                {
                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslation", "SegmentTranslation")
                        .WithMany("SegmentTranslationHistory")
                        .HasForeignKey("SegmentTranslationId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Translation", "Translation")
                        .WithMany("SegmentTranslationHistory")
                        .HasForeignKey("TranslationId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("SegmentTranslation");

                    b.Navigation("Translation");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Segment", b =>
                {
                    b.Navigation("SegmentTranslations");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentMetadata", b =>
                {
                    b.Navigation("SegmentTranslations");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslation", b =>
                {
                    b.Navigation("SegmentTranslationHistory");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Translation", b =>
                {
                    b.Navigation("SegmentTranslationHistory");
                });
#pragma warning restore 612, 618
        }
    }
}
